﻿@page "/competitionTeams"
@using Models.CompetitionData
@using Models.TeamData
@using Cronus_Server.Pages.Competition.CompetitionTeam.Dialog
@using Business.Repository.IRepository
@inject ICompetitionTeamRepository CompetitionTeamRepository
@inject ITeamSeasonRepository TeamSeasonRepository
@inject IJSRuntime JsRuntime
@inject Blazored.LocalStorage.ILocalStorageService localStorage
@inject NavigationManager NavigationManager
@inject IModalDialogService ModalDialog

<div class="row mt-4">
    <div class="col-8">
        <h4 class="card-title text-info">Competition Teams</h4>
    </div>
    <div class="col-3 offset-1">
        <button @onclick="() => HandleAddCompetitionTeam(CompetitionId)" class="btn btn-primary form-control">Add new team to competition</button>
    </div>
</div>
<div class="row mt-4">
        <table class="table table-bordered table-hover">
            <thead>
                <tr>
                    <th width="10%">#</th>
                    <th>Name</th>
                    <th width="10%">
                        Actions
                    </th>
                </tr>
            </thead>
            <tbody>
                @if (CompetitionTeams.Any())
                {
                    int i = 1;
                    @foreach (var competitionTeam in CompetitionTeams)
                    {
                        <tr>
                            <td >@i</td>
                            @{i++;}
                            <td>@competitionTeam.Team.Name</td>
                            <td class="d-flex flex-row-reverse">
                                <button class="btn btn-danger" @onclick="() => HandleDelete(competitionTeam.Id)">Delete</button>
                            </td>
                        </tr>
                    }
                }
                else
                {
                    <tr>
                        <td colspan="5">No records found</td>
                    </tr>
                }
            </tbody>
        </table>
</div>

<DeleteConfirmation IsParentComponentProcessing="IsProcessing" ConfirmationChanged="ConfirmDelete_Click"></DeleteConfirmation>

@code {
    [Parameter]
    public int CompetitionId { get; set; }
    private IEnumerable<CompetitionTeamDTO> CompetitionTeams { get; set; } = new List<CompetitionTeamDTO>();
    private IEnumerable<TeamSeasonDTO> TeamSeasons { get; set; } = new List<TeamSeasonDTO>();

    private int? DeleteCompetitionTeamId { get; set; } = null;
    private bool IsProcessing { get; set; } = false;

    protected async override Task OnInitializedAsync()
    {
        CompetitionTeams = await CompetitionTeamRepository.GetAllFromCompetition(CompetitionId);
        TeamSeasons = await TeamSeasonRepository.GetAllFromSeason(await localStorage.GetItemAsync<int>("seasonId"));
    }

    private async Task HandleDelete(int competitionTeamId)
    {
        DeleteCompetitionTeamId = competitionTeamId;
        await JsRuntime.InvokeVoidAsync("ShowDeleteConfirmationModal");
    }
    public async Task ConfirmDelete_Click(bool isConfirmed)
    {
        IsProcessing = true;
        if (isConfirmed && DeleteCompetitionTeamId != null)
        {
            await CompetitionTeamRepository.Delete(DeleteCompetitionTeamId.Value);
            await JsRuntime.ToastrSuccess("Team deleted successfully!");
            CompetitionTeams = await CompetitionTeamRepository.GetAllFromCompetition(CompetitionId);
        }
        await JsRuntime.InvokeVoidAsync("HideDeleteConfirmationModal");
        IsProcessing = false;
    }
    async void HandleAddCompetitionTeam(int competitionId)
    {
        var parameters = new ModalDialogParameters();
        parameters.Add("CompetitionId", CompetitionId);
        parameters.Add("TeamSeasons", TeamSeasons);
        //Modal.Show<DialogAddPlayer>("Add players", parameters);
        var result = await ModalDialog.ShowDialogAsync<CompetitionTeamCreateUpdate>("Add team to competition", new ModalDialogOptions(), parameters);
        CompetitionTeams = await CompetitionTeamRepository.GetAllFromCompetition(CompetitionId);
        StateHasChanged();
    }
}